function obj=grow(obj,newsize);
%create vector that contains elements corresponding to newsize. Retreive
%the elements from a vector thta corresponds to a matrix of size oldsize

% copy elements of old object to new object
obj.data=copyElements(obj.data,obj.size,newsize);
obj.size=newsize;
%__________________________________________________________________________
function newvector=copyElements(oldvector,oldSize,newSize);
% INPUT
%     oldvector: deflatev object holding data for matrix of size oldSize
%     oldSize: non transposed size of matrix

%Because decompressing is faster then compressing, minimize the time needed
%to compress

%Compute the maximum number of elements to write
MAXELM     = 16*10^6/sizeof(get(oldvector,'class'));
SEGSIZE    = get(oldvector,'segmentSize');
MAXSEGMENT =floor(MAXELM/SEGSIZE); %maximimum number of segment to write in one go

%initialize new vector, but copy all properties of old vector except "N"
%and "segment"
newvector=reset(oldvector);
newvector=set(newvector,'N',prod(newSize));

%assign elements of new vector in loop
strt=1;
N=prod(oldSize);
while strt<=N
    last=min(strt+MAXSEGMENT*SEGSIZE-1,N);
    oldrng=uint32(strt):uint32(last); %elements required for new matrix
    newrng=newIndex(oldrng,oldSize,newSize);
    newvector(newrng)=oldvector(oldrng);    
    strt=last+1;
end

%__________________________________________________________________________
function newrng = newIndex(oldrng,oldSize,newSize)
oldrng=double(oldrng);
indices=cell(1,length(oldSize));
[indices{:}]=ind2sub(oldSize,oldrng); %get row col, etc
newrng=sub2ind(newSize,indices{:}); %transform back to linear index
newrng=uint32(newrng);


