function data=subsref(obj,ind)
%exporteer data van object in expressie ?=obj(x1,x2)
% 
% INPUT
%     obj: 
%         handle to deflate object, see constructor
%     ind
%     +----type='()'
%     +----subs={index in dim1,index in dim 2, etc}
          
% EXAMPLES
%     ind=struct('type','()','subs',{':'})

%WIJZ ZIJPP: 20091012: implement special case when only 1 index is provided
if length(ind.subs)==1
    %Single index: 
    %Regardless of size of matrix, always use linear index
    %Get elements directly from deflatev object.      
    data=subsref(obj.data,ind);
    
    if length(ind.subs{1})==1 && ind.subs{1}(1)==':'
        %":" always return vertical vector
        return
    end
    
    %Notes: 
    %If object is horizontal vector:
    %  :  index produces vertical vector
    %  horizontal [] produces horizontal vector
    %  vertical [] produces horizontal vector
    %If object is vertical vector:
    %  :  produces vertical vector
    %  horizontal [] produces vertical vector
    %  vertical [] produces vertical vector
    %If object is matrix:
    %  :  produces vertical vector    
    %  horizontal [] produces horizontal vector
    %  vertical [] produces vertical vector
    
    SZ=size(obj);
    if length(SZ)>2 || all(SZ>1) || SZ(1)==1
        %Orientation of output equals subs.
        %Anything outside this condition is vertical vector
        if ishorizontal(ind.subs{1})
            data=data';
        end
    end    
        
    %deflatev alway return vertical vector    
    return
end

[subscript,OOB]=getSubscript(ind,obj.size);
if OOB
    error('Index exceeds matrix dimensions.');
end

%determine linear indices
if length(subscript{1})>2 && isclosed(subscript{1})
    %EXAMPLE subscript{1}=[1;35752320]
	dims=subscript2dim(subscript);
	subscript{1}(2:end-1)=[];
	rng = sub2indVector(obj.size,subscript{:});
	data=reshape(getclosedrange(obj.data,rng),dims);
else
	[linIndices,dims] = sub2indVector(obj.size,subscript{:});
	data=reshape(obj.data(linIndices),dims);
end
%__________________________________________________________________________
function H=ishorizontal(subs)
%Determine if index implies horizontal or vertical output
% 
% INPUT
%     subs: index
%     
% EXAMPLES
%     Command         subs value
%     a([1 2 5])  ==> [1 2 5]
%     a([1 2 5]') ==> [1 2 5]'
%     a(:)        ==> ':'
%     a(1:end)    ==> [1 2 ... Height] 
%     a([])       ==> []

sz=size(subs);
H=sz(1)==1;
