function extractDeflateUtils

%This script extract all m-files required for the deflate matrix and
%deflate vector utility.

% Procedure for extracting deflate utils:
% -1-
% Copy this script to directory outsite "@" directory so that it can be
% included in Matlab path
% -2-
% Run the script
% -3-
% Change parameter CUSAGE to true in defalteutils/compress
% -4-
% Test extraction in a separate Matlab session


% Root on source computer:
Root    =fileparts(fileparts(which('deflate')));

%location of startup etc
Startup =fullfile(Root,'@deflate','extractDeflate');

%Extract files to this location
TargetExtract =fullfile(Root,'@deflate','extractDeflate','extracted');
TargetDeflateUt=fullfile(TargetExtract,'deflateutils');

try
rmdir(TargetExtract,'s');
catch
end
mkdir(TargetExtract);
%An empty dir has been created
[status,message]=copyfile(fullfile(Root,'@deflate','*.m'),fullfile(TargetExtract,'@deflate'),'f');
[status,message]=copyfile(fullfile(Root,'@deflate','private','*.m'),fullfile(TargetExtract,'@deflate','private'),'f');
[status,message]=copyfile(fullfile(Root,'@deflatev','*.m'),fullfile(TargetExtract,'@deflatev'),'f');
[status,message]=copyfile(fullfile(Root,'@deflatev','private','*.m'),fullfile(TargetExtract,'@deflatev','private'),'f');
[status,message]=copyfile(fullfile(Root,'@deflate','private','*.m'),fullfile(TargetExtract,'@deflatev','private'),'f');
[status,message]=copyfile(fullfile(Startup,'*.m'),TargetExtract,'f');
mkdir(TargetDeflateUt)

%Get latest version of utils:
s=dir(fullfile(Root,'@deflate','extractDeflate','deflateutils','*.m*'));
for k=1:length(s)
    this=s(k).name;
    nm=which(this);
    if isempty(nm)
        error('Utility %s not found on path',this);
    else
        copyfile(nm,fullfile(TargetDeflateUt,this))
        disp(sprintf('Copy utility "%s"', this))
    end    
end



