function testdeflatev
%this function contains various test scripts.
%copy and paste to command window to run them or use Matlab cell mode

%%
a=deflatev('empty',int16(0));
if length(a)~=0, error('length~=0');end
a(3)=int16(3);
if length(a)~=3, error('length~=3');end
V2=a(2);
if V2,   error('V2~=0');end
V3=a(3);
if V3~=3, error('V3~=3');end
if ~strcmp(class(V3),'int16'),error('class V3~= int16');end     
disp('TEST 1 OK');
%%
a=deflatev('empty',int16(0),'N',10);
if length(a)~=10, error('length~=10');end
disp('TEST 2 OK');
%%
M=rand(1000^2,1);
tic
mm=deflatev(M,'mode','mem');
dprintf('Timing mode memory: %f',toc)
tic
m=deflatev(M);
dprintf('Timing mode compressed: %f',toc)
if ~is_eq(mm(:),m(:)),error('Not equal');end
if ~is_eq(mm(:),M(:)),error('Not equal');end
disp('TEST 3 OK');
%%
a=deflatev;
a(11:15)=11:15;
try
    a(13:20)=1:120;
    error('Error not detected');
catch
    dprintf('Error Caught: %s',lasterr);
    disp('TEST 4 OK');
end

%Check if unassigned value is returned
a=deflatev;
a(11)=11;
a(120000)=1;
val=(a(3));
disp('TEST 5a OK');
val=(a(12));
disp('TEST 5b OK');
val=a(5:12);
disp('TEST 5d OK');
val=a(5:110000);
try
    val=a(5:190000)
    error('Error not detected');
catch
    dprintf('Error Caught: %s',lasterr);
    disp('TEST 5e OK');
end
%%
%Randomized test
N=50000;
A=rand(N,1);
AS=false(N,1);
MISVAL=pi;
a=deflatev('segmentsize',2000,'N',N,'emptyvalue',MISVAL);
for k=1:100
    if rem(k,10)==0,   disp(k);
        if ~is_eq(a(find(AS)),A(AS))
            error('Not equal');
        end
        if any(a(find(~AS))~=MISVAL)
            error('Empty value incorrect');
        end
        aa=full(a);
        f=find(aa~=MISVAL);
        line(f,k+ones(size(f)),'linew',2);
    end
    rng1=inf;
    rng2=1;
    while rng1>=rng2
    rng1=max(1,round(N*rand(1)));
    rng2=max(1,round(N*rand(1)));
    end
    rng=rng1:rng2;
    a(rng)=A(rng);
    AS(rng)=true;
end
disp('TEST 6 OK');

%test method getclosedrange
N=10^6;
a=deflatev(int32(1:N));
M=100500;
rng1=[M,M+10];
rng2=M:M+10;
tic
b1=getclosedrange(a,rng1);
dprintf('getrange in: %f',toc);
tic
b2=a(rng2);
dprintf('subsref in: %f',toc);
if ~is_eq(b1,b2);error('Not equal');end
disp('TEST 7 OK');
%%
%test  nonexistent numbers
a=deflatev('segmentsize',2000,'N',N);



a=deflatev;
a(11:15)=11:15;
a(13:20)=113:120;
disp(a(10:20))
a(10^6)=1;
a(12)
m=deflatev(1:9);
m=full(m)
%%
data=rand(10^6+127,1);
a=deflatev(data);
aa=set(a,'mode','mem');
is_eq(aa(:),data);
aaa=set(aa,'mode','comp');
is_eq(aaa(:),data);
%%
obj=deflatev(1:10);
obj=setclosedrange(obj,[1 100],1:100)
N=23700;
obj=deflatev(1:N,'segm',1000);
obj=setclosedrange(obj,[1 N],1:N)
is_eq((1:N)',obj(:))

